"use strict";
(self["webpackChunkjupyterlab_colab_bridge"] = self["webpackChunkjupyterlab_colab_bridge"] || []).push([["lib_index_js"],{

/***/ "./lib/colabCell.js":
/*!**************************!*\
  !*** ./lib/colabCell.js ***!
  \**************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "ColabCodeCell": () => (/* binding */ ColabCodeCell)
/* harmony export */ });
/* harmony import */ var _jupyterlab_cells__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @jupyterlab/cells */ "webpack/sharing/consume/default/@jupyterlab/cells");
/* harmony import */ var _jupyterlab_cells__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_cells__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _colabCommand__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./colabCommand */ "./lib/colabCommand/index.js");
/* harmony import */ var _constants__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./constants */ "./lib/constants.js");



class ColabCodeCell extends _jupyterlab_cells__WEBPACK_IMPORTED_MODULE_0__.CodeCell {
    constructor(options) {
        super(options);
        this.colabEditing = false;
        this.displayMode = _constants__WEBPACK_IMPORTED_MODULE_1__.DisplayMode.Both;
        this.processColabElement(true);
        this.setDisplayMode(this.displayMode);
        this.model.contentChanged.connect(() => {
            if (!this.colabEditing) {
                this.processColabElement();
            }
        });
    }
    setColabEditing(value) {
        this.colabEditing = value;
    }
    setDisplayMode(mode) {
        this.displayMode = mode;
        this.node.classList.remove(_constants__WEBPACK_IMPORTED_MODULE_1__.DISPLAY_MODE_CODE);
        this.node.classList.remove(_constants__WEBPACK_IMPORTED_MODULE_1__.DISPLAY_MODE_FORM);
        this.node.classList.remove(_constants__WEBPACK_IMPORTED_MODULE_1__.DISPLAY_MODE_BOTH);
        this.node.classList.add(_constants__WEBPACK_IMPORTED_MODULE_1__.DISPLAY_MODE_PREFIX + this.displayMode);
        this.editorWidget.update();
    }
    clearInjectedToolbarBtns() {
        this.node
            .querySelector('.' + _constants__WEBPACK_IMPORTED_MODULE_1__.TOOLBAR_BUTTON_CONTAINER_CLASS_NAME)
            ?.remove();
    }
    injectToolbarBtns() {
        if (!this.node.querySelector(_constants__WEBPACK_IMPORTED_MODULE_1__.TOOLBAR_INJECTION_SELECTOR)) {
            setTimeout(() => this.injectToolbarBtns(), 100);
        }
        else {
            if (!this.node.querySelector('.' + _constants__WEBPACK_IMPORTED_MODULE_1__.TOOLBAR_BUTTON_CONTAINER_CLASS_NAME)) {
                this.node.querySelector(_constants__WEBPACK_IMPORTED_MODULE_1__.TOOLBAR_INJECTION_SELECTOR)?.prepend(_colabCommand__WEBPACK_IMPORTED_MODULE_2__.colabCommand.toolbarBtns(_constants__WEBPACK_IMPORTED_MODULE_1__.TOOLBAR_BUTTON_CONTAINER_CLASS_NAME, () => {
                    if (this.displayMode === _constants__WEBPACK_IMPORTED_MODULE_1__.DisplayMode.Form) {
                        this.setDisplayMode(_constants__WEBPACK_IMPORTED_MODULE_1__.DisplayMode.Both);
                    }
                    else {
                        this.setDisplayMode(_constants__WEBPACK_IMPORTED_MODULE_1__.DisplayMode.Form);
                    }
                }, () => {
                    if (this.displayMode === _constants__WEBPACK_IMPORTED_MODULE_1__.DisplayMode.Code) {
                        this.setDisplayMode(_constants__WEBPACK_IMPORTED_MODULE_1__.DisplayMode.Both);
                    }
                    else {
                        this.setDisplayMode(_constants__WEBPACK_IMPORTED_MODULE_1__.DisplayMode.Code);
                    }
                }));
            }
        }
    }
    processColabElement(init = false) {
        const colabContainerElem = document.createElement('div');
        colabContainerElem.classList.add(_constants__WEBPACK_IMPORTED_MODULE_1__.COLAB_CLASS_NAME);
        const code = this.model.value.text;
        const colabElems = [];
        code
            .trim()
            .split('\n')
            .forEach((line, i) => {
            const commandType = _colabCommand__WEBPACK_IMPORTED_MODULE_2__.colabCommand.match(line);
            // remove the injected title if the first non empty line is not a title
            if (i === 0 && (!commandType || commandType !== _constants__WEBPACK_IMPORTED_MODULE_1__.CommandType.Title)) {
                this.node.querySelector('.' + _constants__WEBPACK_IMPORTED_MODULE_1__.TITLE_CLASS_NAME)?.remove();
            }
            if (commandType) {
                // only support title as the first non empty title
                if (i !== 0 && commandType === _constants__WEBPACK_IMPORTED_MODULE_1__.CommandType.Title) {
                    return;
                }
                if (i === 0 && commandType === _constants__WEBPACK_IMPORTED_MODULE_1__.CommandType.Title) {
                    // display mode can only be set on first line title
                    // also it will only be considered during init, to keep the same behavior as colab
                    // after init, changing display mode won't do anything
                    const displayMode = _colabCommand__WEBPACK_IMPORTED_MODULE_2__.colabCommand.parseDisplayMode(line);
                    if (displayMode) {
                        init && this.setDisplayMode(displayMode.displayMode);
                        line = displayMode.newLine;
                    }
                }
                if (commandType === _constants__WEBPACK_IMPORTED_MODULE_1__.CommandType.Markdown) {
                    _colabCommand__WEBPACK_IMPORTED_MODULE_2__.markdownBuilder.add(_colabCommand__WEBPACK_IMPORTED_MODULE_2__.colabCommand.trim(commandType, line));
                }
                else {
                    if (_colabCommand__WEBPACK_IMPORTED_MODULE_2__.markdownBuilder.get()) {
                        colabElems.push(_colabCommand__WEBPACK_IMPORTED_MODULE_2__.markdownBuilder.build());
                        _colabCommand__WEBPACK_IMPORTED_MODULE_2__.markdownBuilder.clear();
                    }
                    const builtElem = _colabCommand__WEBPACK_IMPORTED_MODULE_2__.colabCommand.build(commandType, line, i, (newLine) => {
                        const newText = this.model.value.text.split('\n');
                        newText[i] = newLine;
                        this.model.value.text = newText.join('\n');
                        this.update();
                    }, (value) => this.setColabEditing(value));
                    if (commandType === _constants__WEBPACK_IMPORTED_MODULE_1__.CommandType.Title) {
                        this.node.querySelector('.' + _constants__WEBPACK_IMPORTED_MODULE_1__.TITLE_CLASS_NAME)?.remove();
                        builtElem && this.node.prepend(builtElem);
                    }
                    else {
                        colabElems.push(builtElem);
                    }
                }
            }
            else {
                // if this is a non-markdown line, check and build the markdown we have
                if (_colabCommand__WEBPACK_IMPORTED_MODULE_2__.markdownBuilder.get()) {
                    colabElems.push(_colabCommand__WEBPACK_IMPORTED_MODULE_2__.markdownBuilder.build());
                    _colabCommand__WEBPACK_IMPORTED_MODULE_2__.markdownBuilder.clear();
                }
            }
        });
        // if the last line(s) are markdown, we have to trigger the build here
        if (_colabCommand__WEBPACK_IMPORTED_MODULE_2__.markdownBuilder.get()) {
            colabElems.push(_colabCommand__WEBPACK_IMPORTED_MODULE_2__.markdownBuilder.build());
            _colabCommand__WEBPACK_IMPORTED_MODULE_2__.markdownBuilder.clear();
        }
        // filter and build the final form container elemenr
        colabElems
            .filter(elem => !!elem)
            .forEach(elem => colabContainerElem.appendChild(elem));
        this.node.querySelector(`.${_constants__WEBPACK_IMPORTED_MODULE_1__.COLAB_CLASS_NAME}`)?.remove();
        if (colabContainerElem.childNodes.length > 0) {
            this.injectToolbarBtns();
            this.setDisplayMode(this.displayMode);
            colabContainerElem.appendChild(_colabCommand__WEBPACK_IMPORTED_MODULE_2__.colabCommand.showCodeBtn(_constants__WEBPACK_IMPORTED_MODULE_1__.CELL_SHOW_CODE_CLASS_NAME, () => this.setDisplayMode(_constants__WEBPACK_IMPORTED_MODULE_1__.DisplayMode.Both)));
            this.node
                .querySelector('.jp-Cell-inputWrapper')
                ?.appendChild(colabContainerElem);
            this.node.classList.add(_constants__WEBPACK_IMPORTED_MODULE_1__.CELL_CLASS_NAME);
        }
        else {
            this.node.classList.remove(_constants__WEBPACK_IMPORTED_MODULE_1__.CELL_CLASS_NAME);
            this.node.classList.remove(_constants__WEBPACK_IMPORTED_MODULE_1__.DISPLAY_MODE_CODE);
            this.node.classList.remove(_constants__WEBPACK_IMPORTED_MODULE_1__.DISPLAY_MODE_FORM);
            this.node.classList.remove(_constants__WEBPACK_IMPORTED_MODULE_1__.DISPLAY_MODE_BOTH);
            this.clearInjectedToolbarBtns();
        }
    }
}


/***/ }),

/***/ "./lib/colabCommand/builder.js":
/*!*************************************!*\
  !*** ./lib/colabCommand/builder.js ***!
  \*************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "colabCommandBuilder": () => (/* binding */ colabCommandBuilder)
/* harmony export */ });
/* harmony import */ var _constants__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../constants */ "./lib/constants.js");
/* harmony import */ var _utils_pubsub__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../utils/pubsub */ "./lib/utils/pubsub.js");


const colabCommandBuilder = (targetType, paramObj, update, setColabEditing, key) => {
    if (targetType === _constants__WEBPACK_IMPORTED_MODULE_0__.BuildTargetType.ValueList) {
        const selectElemWrapper = document.createElement('div');
        selectElemWrapper.classList.add(_constants__WEBPACK_IMPORTED_MODULE_0__.PARAM_EXTEND_ELEMENT_CLASS_NAME);
        selectElemWrapper.classList.add(_constants__WEBPACK_IMPORTED_MODULE_0__.SELECT_WRAPPER_CLASS_NAME);
        const selectElem = document.createElement('select');
        selectElem.classList.add(_constants__WEBPACK_IMPORTED_MODULE_0__.PARAM_EXTEND_ELEMENT_CLASS_NAME);
        paramObj.valueList &&
            paramObj.valueList.forEach((value, i) => {
                const optionElem = document.createElement('option');
                optionElem.innerHTML = value;
                selectElem.appendChild(optionElem);
            });
        selectElem.value =
            paramObj.config.type === _constants__WEBPACK_IMPORTED_MODULE_0__.ParamType.String
                ? paramObj.value ?? ''
                : paramObj.rawValue ?? '';
        selectElem.addEventListener('change', e => {
            setColabEditing(true); // avoid the update() to trigger the unwanted colab cell rendering
            let value;
            if (paramObj.config.type === _constants__WEBPACK_IMPORTED_MODULE_0__.ParamType.Raw && paramObj.valueList) {
                // eslint-disable-next-line @typescript-eslint/no-unsafe-assignment
                value =
                    paramObj.valueList?.[e.target.selectedIndex];
            }
            else {
                value = e.target.value;
            }
            update(value);
            // make sure to sync the value with the input
            _utils_pubsub__WEBPACK_IMPORTED_MODULE_1__["default"].publish(`select-value${(key ?? '').toString()}`, value);
            setColabEditing(false);
        });
        selectElemWrapper.appendChild(selectElem);
        // if allow-input is true, add the input and arrow button on top of the select elem
        if (paramObj.config.allowInput) {
            const inputElem = document.createElement('input');
            inputElem.classList.add(_constants__WEBPACK_IMPORTED_MODULE_0__.PARAM_EXTEND_ELEMENT_CLASS_NAME);
            inputElem.classList.add(_constants__WEBPACK_IMPORTED_MODULE_0__.PARAM_ALLOW_INPUT_INPUT);
            inputElem.value =
                paramObj.config.type === _constants__WEBPACK_IMPORTED_MODULE_0__.ParamType.String
                    ? paramObj.value ?? ''
                    : paramObj.rawValue ?? '';
            inputElem.addEventListener('focus', _ => {
                setColabEditing(true);
            });
            inputElem.addEventListener('blur', _ => {
                setColabEditing(false);
            });
            let updateTriggeredBySelect = false;
            inputElem.addEventListener('input', e => {
                if (!updateTriggeredBySelect) {
                    update(e.target.value);
                    selectElem.value = e.target.value;
                }
                updateTriggeredBySelect = false;
            });
            // listen to the value change triggered by the dropdown menu
            _utils_pubsub__WEBPACK_IMPORTED_MODULE_1__["default"].subscribe(`select-value${(key ?? '').toString()}`, (value) => {
                updateTriggeredBySelect = true;
                inputElem.value = value;
                inputElem.dispatchEvent(new Event('input'));
            });
            selectElemWrapper.appendChild(inputElem);
        }
        return selectElemWrapper;
    }
    else if (targetType === _constants__WEBPACK_IMPORTED_MODULE_0__.BuildTargetType.InputStringOrRaw ||
        targetType === _constants__WEBPACK_IMPORTED_MODULE_0__.BuildTargetType.InputNumberOrIntegerOrDate) {
        const inputElem = document.createElement('input');
        inputElem.classList.add(_constants__WEBPACK_IMPORTED_MODULE_0__.PARAM_EXTEND_ELEMENT_CLASS_NAME);
        inputElem.value =
            paramObj.config.type ===
                (targetType === _constants__WEBPACK_IMPORTED_MODULE_0__.BuildTargetType.InputStringOrRaw
                    ? _constants__WEBPACK_IMPORTED_MODULE_0__.ParamType.String
                    : _constants__WEBPACK_IMPORTED_MODULE_0__.ParamType.Date)
                ? paramObj.value ?? ''
                : paramObj.rawValue ?? '';
        paramObj.config.type === _constants__WEBPACK_IMPORTED_MODULE_0__.ParamType.Date && (inputElem.type = 'date');
        inputElem.addEventListener('focus', _ => {
            setColabEditing(true);
        });
        inputElem.addEventListener('blur', _ => {
            setColabEditing(false);
        });
        inputElem.addEventListener('input', e => {
            update(e.target.value);
        });
        return inputElem;
    }
    else if (targetType === _constants__WEBPACK_IMPORTED_MODULE_0__.BuildTargetType.Checkbox) {
        const checkboxElem = document.createElement('input');
        checkboxElem.type = 'checkbox';
        checkboxElem.checked = paramObj.rawValue === 'True';
        checkboxElem.addEventListener('change', e => {
            setColabEditing(true);
            update(e.target.checked ? 'True' : 'False');
            setColabEditing(false);
        });
        return checkboxElem;
    }
    else if (targetType === _constants__WEBPACK_IMPORTED_MODULE_0__.BuildTargetType.Slider) {
        const inputElem = document.createElement('input');
        inputElem.classList.add(_constants__WEBPACK_IMPORTED_MODULE_0__.PARAM_EXTEND_ELEMENT_CLASS_NAME);
        inputElem.value =
            paramObj.rawValue ||
                (paramObj.config.min && paramObj.config.min.toString()) ||
                (paramObj.config.max && paramObj.config.max.toString()) ||
                '0';
        inputElem.type = 'range';
        paramObj.config.min && (inputElem.min = paramObj.config.min.toString());
        paramObj.config.max && (inputElem.max = paramObj.config.max.toString());
        paramObj.config.step && (inputElem.step = paramObj.config.step.toString());
        inputElem.addEventListener('focus', _ => {
            setColabEditing(true);
        });
        inputElem.addEventListener('blur', _ => {
            setColabEditing(false);
        });
        inputElem.addEventListener('input', e => {
            update(e.target.value);
        });
        return inputElem;
    }
};


/***/ }),

/***/ "./lib/colabCommand/index.js":
/*!***********************************!*\
  !*** ./lib/colabCommand/index.js ***!
  \***********************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "colabCommand": () => (/* binding */ colabCommand),
/* harmony export */   "markdownBuilder": () => (/* binding */ markdownBuilder)
/* harmony export */ });
/* harmony import */ var marked__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! marked */ "webpack/sharing/consume/default/marked/marked");
/* harmony import */ var marked__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(marked__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _locale__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../locale */ "./lib/locale/index.js");
/* harmony import */ var _constants__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../constants */ "./lib/constants.js");
/* harmony import */ var _utils_cache__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../utils/cache */ "./lib/utils/cache.js");
/* harmony import */ var _utils_utils__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! ../utils/utils */ "./lib/utils/utils.js");
/* harmony import */ var _trimmer__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./trimmer */ "./lib/colabCommand/trimmer.js");
/* harmony import */ var _matcher__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./matcher */ "./lib/colabCommand/matcher.js");
/* harmony import */ var _updater__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./updater */ "./lib/colabCommand/updater.js");
/* harmony import */ var _builder__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./builder */ "./lib/colabCommand/builder.js");









// wait until the jupyterlab sets the language code
setTimeout(() => _locale__WEBPACK_IMPORTED_MODULE_1__.localeText.setLang(document.documentElement.lang), 0);
// initialize the element cache with maxSize
const elemCache = new _utils_cache__WEBPACK_IMPORTED_MODULE_2__.LRUCache(100);
const makeLegalString = (rawValue, value) => {
    if (!(/'.*'/.exec(rawValue) || /".*"/.exec(rawValue))) {
        value = `"${value.replaceAll('"', '\\"')}"`;
    }
    return value;
};
// verify the number values
const numberValueAssert = {
    [_constants__WEBPACK_IMPORTED_MODULE_3__.ParamType.Number]: ({ value }) => !isNaN(Number(value)) && !isNaN(parseFloat(value)),
    [_constants__WEBPACK_IMPORTED_MODULE_3__.ParamType.Slider]: ({ value, min, max }) => {
        if (numberValueAssert.number({ value }) &&
            (min !== undefined ? parseFloat(value) >= min : true) &&
            (max !== undefined ? parseFloat(value) <= max : true)) {
            return true;
        }
        return false;
    },
    [_constants__WEBPACK_IMPORTED_MODULE_3__.ParamType.Integer]: ({ value }) => Number.isInteger(Number(value))
};
// error messages for corresponding number type
const numberValueErrorMsg = {
    [_constants__WEBPACK_IMPORTED_MODULE_3__.ParamType.Number]: _locale__WEBPACK_IMPORTED_MODULE_1__.localeText.getText(_constants__WEBPACK_IMPORTED_MODULE_3__.LocaleTextName.NUMBER_ERROR_MESSAGE),
    [_constants__WEBPACK_IMPORTED_MODULE_3__.ParamType.Slider]: _locale__WEBPACK_IMPORTED_MODULE_1__.localeText.getText(_constants__WEBPACK_IMPORTED_MODULE_3__.LocaleTextName.SLIDER_ERROR_MESSAGE),
    [_constants__WEBPACK_IMPORTED_MODULE_3__.ParamType.Integer]: _locale__WEBPACK_IMPORTED_MODULE_1__.localeText.getText(_constants__WEBPACK_IMPORTED_MODULE_3__.LocaleTextName.INTEGER_ERROR_MESSAGE)
};
// build the error message DOM element with the error message
const createErrorMsgElem = (msg) => {
    const errorMsgElem = document.createElement('div');
    errorMsgElem.classList.add(_constants__WEBPACK_IMPORTED_MODULE_3__.ERROR_MESSAGE_CLASS_NAME);
    errorMsgElem.innerHTML = msg;
    return errorMsgElem;
};
// build the error message DOM element with the error message
const createBreakLineElem = () => {
    const brElem = document.createElement('div');
    brElem.classList.add(_constants__WEBPACK_IMPORTED_MODULE_3__.BREAK_LINE_ELEMENT);
    return brElem;
};
// generic assert function to make sure the required fields are populated
const assert = (obj, ...fields) => {
    for (const field of fields) {
        if (obj[field] === null || obj[field] === undefined) {
            return _locale__WEBPACK_IMPORTED_MODULE_1__.localeText.getTextFn(_constants__WEBPACK_IMPORTED_MODULE_3__.LocaleTextName.ASSERT_ERROR_MESSAGE_FN)(field);
        }
    }
};
const colabCommand = {
    match(line) {
        for (const commandType of Object.values(_constants__WEBPACK_IMPORTED_MODULE_3__.CommandType)) {
            if ((0,_matcher__WEBPACK_IMPORTED_MODULE_4__.colabCommandMatcher)(commandType, line)) {
                return commandType;
            }
        }
    },
    trim(type, line) {
        return _trimmer__WEBPACK_IMPORTED_MODULE_5__.colabCommandTrimmer[type](line);
    },
    updateLine(type, line, replaceStr, withStr, quoteType, needQuotation = false) {
        return _updater__WEBPACK_IMPORTED_MODULE_6__.colabCommandUpdater[type](line, replaceStr, withStr, quoteType, needQuotation);
    },
    build(type, line, lineNumber, updateCell, setColabEditing) {
        try {
            const cachedElem = elemCache.get(line + lineNumber.toString());
            if (cachedElem) {
                return cachedElem;
            }
            const colabElem = document.createElement('div');
            const validateValue = (paramType, value, clearPreviousError) => {
                if (clearPreviousError) {
                    colabElem.querySelector('.' + _constants__WEBPACK_IMPORTED_MODULE_3__.ERROR_MESSAGE_CLASS_NAME)?.remove();
                    colabElem.querySelector('.' + _constants__WEBPACK_IMPORTED_MODULE_3__.BREAK_LINE_ELEMENT)?.remove();
                    colabElem.classList.remove(_constants__WEBPACK_IMPORTED_MODULE_3__.ERROR_CLASS_NAME);
                }
                if (numberValueAssert[paramType] &&
                    !numberValueAssert[paramType](value)) {
                    const errorMsgElem = createErrorMsgElem(numberValueErrorMsg[paramType]);
                    colabElem.appendChild(createBreakLineElem());
                    colabElem.appendChild(errorMsgElem);
                    colabElem.classList.add(_constants__WEBPACK_IMPORTED_MODULE_3__.ERROR_CLASS_NAME);
                }
            };
            const trimmedObj = this.trim(type, line);
            // assertions
            if (type === _constants__WEBPACK_IMPORTED_MODULE_3__.CommandType.Param) {
                const paramObj = trimmedObj;
                if (assert(paramObj, 'name')) {
                    const errorMsg = document.createElement('div');
                    errorMsg.classList.add(_constants__WEBPACK_IMPORTED_MODULE_3__.ERROR_MESSAGE_CLASS_NAME);
                    errorMsg.innerHTML = assert(paramObj, 'name');
                    return errorMsg;
                }
            }
            // build the form
            if (type === _constants__WEBPACK_IMPORTED_MODULE_3__.CommandType.Param) {
                const paramObj = trimmedObj;
                // variable name element
                const varNameElem = document.createElement('span');
                varNameElem.innerHTML = paramObj.name + ':';
                varNameElem.classList.add(_constants__WEBPACK_IMPORTED_MODULE_3__.PARAM_NAME_CLASS_NAME);
                // if no type is provided, set it to string by default
                if (!paramObj.config) {
                    paramObj.config = { type: _constants__WEBPACK_IMPORTED_MODULE_3__.ParamType.String };
                }
                if (!paramObj.config.type) {
                    paramObj.config.type = _constants__WEBPACK_IMPORTED_MODULE_3__.ParamType.String;
                }
                // string and raw share most code, except when you need to use the value
                if (paramObj.config.type === _constants__WEBPACK_IMPORTED_MODULE_3__.ParamType.String ||
                    paramObj.config.type === _constants__WEBPACK_IMPORTED_MODULE_3__.ParamType.Raw) {
                    // build the dropdown element if valueList is provided
                    if (paramObj.valueList) {
                        const selectElemWrapper = (0,_builder__WEBPACK_IMPORTED_MODULE_7__.colabCommandBuilder)(_constants__WEBPACK_IMPORTED_MODULE_3__.BuildTargetType.ValueList, paramObj, (value) => {
                            updateCacheAndCell(this.updateLine(type, line, paramObj.config.type === _constants__WEBPACK_IMPORTED_MODULE_3__.ParamType.String
                                ? paramObj.value
                                : paramObj.rawValue, paramObj.config.type === _constants__WEBPACK_IMPORTED_MODULE_3__.ParamType.String
                                ? makeLegalString(paramObj.rawValue, value)
                                : value, paramObj.quoteType, paramObj.config.type === _constants__WEBPACK_IMPORTED_MODULE_3__.ParamType.String));
                        }, setColabEditing, lineNumber);
                        colabElem.appendChild(varNameElem);
                        selectElemWrapper && colabElem.appendChild(selectElemWrapper);
                    }
                    else {
                        const inputElem = (0,_builder__WEBPACK_IMPORTED_MODULE_7__.colabCommandBuilder)(_constants__WEBPACK_IMPORTED_MODULE_3__.BuildTargetType.InputStringOrRaw, paramObj, (value) => {
                            updateCacheAndCell(this.updateLine(type, line, paramObj.config.type === _constants__WEBPACK_IMPORTED_MODULE_3__.ParamType.String
                                ? paramObj.value
                                : paramObj.rawValue, paramObj.config.type === _constants__WEBPACK_IMPORTED_MODULE_3__.ParamType.String
                                ? makeLegalString(paramObj.rawValue, value)
                                : value, paramObj.quoteType, paramObj.config.type === _constants__WEBPACK_IMPORTED_MODULE_3__.ParamType.String));
                        }, setColabEditing);
                        const quotationElem = document.createElement('span');
                        quotationElem.innerHTML = '"';
                        quotationElem.classList.add(_constants__WEBPACK_IMPORTED_MODULE_3__.PARAM_QUOTATION_CLASS_NAME);
                        colabElem.appendChild(varNameElem);
                        paramObj.config.type === _constants__WEBPACK_IMPORTED_MODULE_3__.ParamType.String &&
                            colabElem.appendChild(quotationElem);
                        inputElem && colabElem.appendChild(inputElem);
                        paramObj.config.type === _constants__WEBPACK_IMPORTED_MODULE_3__.ParamType.String &&
                            colabElem.appendChild(quotationElem.cloneNode(true));
                    }
                }
                else if (paramObj.config.type === _constants__WEBPACK_IMPORTED_MODULE_3__.ParamType.Number ||
                    paramObj.config.type === _constants__WEBPACK_IMPORTED_MODULE_3__.ParamType.Integer ||
                    paramObj.config.type === _constants__WEBPACK_IMPORTED_MODULE_3__.ParamType.Date) {
                    const paramType = paramObj.config.type;
                    const inputElem = (0,_builder__WEBPACK_IMPORTED_MODULE_7__.colabCommandBuilder)(_constants__WEBPACK_IMPORTED_MODULE_3__.BuildTargetType.InputNumberOrIntegerOrDate, paramObj, (value) => {
                        paramType !== _constants__WEBPACK_IMPORTED_MODULE_3__.ParamType.Date &&
                            validateValue(paramType, { value }, true);
                        updateCacheAndCell(this.updateLine(type, line, paramObj.config.type === _constants__WEBPACK_IMPORTED_MODULE_3__.ParamType.Date
                            ? paramObj.value
                            : paramObj.rawValue, value, paramObj.quoteType, true));
                    }, setColabEditing);
                    colabElem.appendChild(varNameElem);
                    inputElem && colabElem.appendChild(inputElem);
                    // verify the number format after the init process
                    paramType !== _constants__WEBPACK_IMPORTED_MODULE_3__.ParamType.Date &&
                        validateValue(paramType, {
                            value: inputElem.value
                        });
                }
                else if (paramObj.config.type === _constants__WEBPACK_IMPORTED_MODULE_3__.ParamType.Boolean) {
                    const checkboxElem = (0,_builder__WEBPACK_IMPORTED_MODULE_7__.colabCommandBuilder)(_constants__WEBPACK_IMPORTED_MODULE_3__.BuildTargetType.Checkbox, paramObj, (value) => {
                        updateCacheAndCell(this.updateLine(type, line, paramObj.rawValue, value, paramObj.quoteType));
                    }, setColabEditing);
                    colabElem.appendChild(varNameElem);
                    checkboxElem && colabElem.appendChild(checkboxElem);
                }
                else if (paramObj.config.type === _constants__WEBPACK_IMPORTED_MODULE_3__.ParamType.Slider) {
                    const paramType = paramObj.config.type;
                    const createSliderValueElem = (value) => {
                        const valueElem = document.createElement('span');
                        valueElem.classList.add(_constants__WEBPACK_IMPORTED_MODULE_3__.SLIDER_VALUE_CLASS_NAME);
                        valueElem.innerHTML = value;
                        return valueElem;
                    };
                    const valueElem = createSliderValueElem(paramObj.rawValue);
                    const inputElem = (0,_builder__WEBPACK_IMPORTED_MODULE_7__.colabCommandBuilder)(_constants__WEBPACK_IMPORTED_MODULE_3__.BuildTargetType.Slider, paramObj, (value) => {
                        validateValue(paramType, {
                            value: value,
                            min: paramObj.config.min,
                            max: paramObj.config.max
                        }, true);
                        valueElem.innerHTML = value;
                        const oldValueElem = colabElem.querySelector('.' + _constants__WEBPACK_IMPORTED_MODULE_3__.SLIDER_VALUE_CLASS_NAME);
                        const newValueElem = createSliderValueElem(value);
                        oldValueElem &&
                            colabElem.replaceChild(newValueElem, oldValueElem);
                        updateCacheAndCell(this.updateLine(type, line, paramObj.rawValue, value, paramObj.quoteType));
                    }, setColabEditing);
                    colabElem.appendChild(varNameElem);
                    inputElem && colabElem.appendChild(inputElem);
                    colabElem.appendChild(valueElem);
                    // verify the number format after the init process
                    validateValue(paramType, {
                        value: paramObj.rawValue,
                        min: Number(paramObj.config.min),
                        max: Number(paramObj.config.max)
                    });
                }
                else {
                    const errorMsgElem = createErrorMsgElem(_locale__WEBPACK_IMPORTED_MODULE_1__.localeText.getTextFn(_constants__WEBPACK_IMPORTED_MODULE_3__.LocaleTextName.CELL_BUILD_ERROR_MESSAGE_FN)(line));
                    colabElem.appendChild(errorMsgElem);
                    colabElem.classList.add(_constants__WEBPACK_IMPORTED_MODULE_3__.ERROR_CLASS_NAME);
                }
                colabElem.classList.add(_constants__WEBPACK_IMPORTED_MODULE_3__.PARAM_CLASS_NAME);
            }
            else if (type === _constants__WEBPACK_IMPORTED_MODULE_3__.CommandType.Title) {
                const titleElem = document.createElement('div');
                titleElem.classList.add(_constants__WEBPACK_IMPORTED_MODULE_3__.JUPYTER_LAB_MARKDOWN_CLASS_NAME);
                titleElem.innerHTML = marked__WEBPACK_IMPORTED_MODULE_0__.marked.parse(trimmedObj.value);
                colabElem.classList.add(_constants__WEBPACK_IMPORTED_MODULE_3__.TITLE_CLASS_NAME);
                colabElem.appendChild(titleElem);
            }
            const updateCacheAndCell = (newLine) => {
                elemCache.remove(line + lineNumber.toString());
                elemCache.set(newLine + lineNumber.toString(), colabElem);
                updateCell(newLine);
            };
            elemCache.set(line + lineNumber.toString(), colabElem);
            return colabElem;
        }
        catch (e) {
            return createErrorMsgElem(_locale__WEBPACK_IMPORTED_MODULE_1__.localeText.getTextFn(_constants__WEBPACK_IMPORTED_MODULE_3__.LocaleTextName.CELL_BUILD_ERROR_MESSAGE_FN)(line));
        }
    },
    // displayMode is a special case because it's like an additional command
    // so we handle it outside of the normal build process
    parseDisplayMode(line) {
        const displayModeStr = [...line.matchAll(/{.*?}/g)][0]?.pop();
        const newLine = line.slice(0, line.indexOf(displayModeStr ?? ''));
        // eslint-disable-next-line @typescript-eslint/no-unsafe-assignment
        const displayModeConfig = displayModeStr &&
            JSON.parse((0,_utils_utils__WEBPACK_IMPORTED_MODULE_8__.strToJSON)(
            // wrap property names with double quotations
            displayModeStr
                .replaceAll("'", '"') // replace existing single quotations with double quotations
                .replace('display-mode', 'displayMode') // strToJSON couldn't handle the dash, remove it first
            ));
        if (displayModeConfig) {
            return {
                displayMode: displayModeConfig.displayMode,
                newLine
            };
        }
    },
    // build toolBar buttons
    toolbarBtns(containerClassName, codeBtnOnClick, formBtnOnClick) {
        const container = document.createElement('div');
        container.classList.add(containerClassName);
        const codeBtnElem = document.createElement('a');
        codeBtnElem.classList.add(_constants__WEBPACK_IMPORTED_MODULE_3__.TOOLBAR_CODE_CLASS_NAME);
        codeBtnElem.addEventListener('click', codeBtnOnClick);
        codeBtnElem.innerHTML =
            '<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 640 512"><!--! Font Awesome Pro 6.2.0 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license (Commercial License) Copyright 2022 Fonticons, Inc. --><path d="M392.8 1.2c-17-4.9-34.7 5-39.6 22l-128 448c-4.9 17 5 34.7 22 39.6s34.7-5 39.6-22l128-448c4.9-17-5-34.7-22-39.6zm80.6 120.1c-12.5 12.5-12.5 32.8 0 45.3L562.7 256l-89.4 89.4c-12.5 12.5-12.5 32.8 0 45.3s32.8 12.5 45.3 0l112-112c12.5-12.5 12.5-32.8 0-45.3l-112-112c-12.5-12.5-32.8-12.5-45.3 0zm-306.7 0c-12.5-12.5-32.8-12.5-45.3 0l-112 112c-12.5 12.5-12.5 32.8 0 45.3l112 112c12.5 12.5 32.8 12.5 45.3 0s12.5-32.8 0-45.3L77.3 256l89.4-89.4c12.5-12.5 12.5-32.8 0-45.3z"/></svg>';
        const divider = document.createElement('div');
        divider.innerHTML = '|';
        const formBtnElem = document.createElement('a');
        formBtnElem.classList.add(_constants__WEBPACK_IMPORTED_MODULE_3__.TOOLBAR_FORM_CLASS_NAME);
        formBtnElem.addEventListener('click', formBtnOnClick);
        formBtnElem.innerHTML =
            '<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 640 512"><!--! Font Awesome Pro 6.2.0 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license (Commercial License) Copyright 2022 Fonticons, Inc. --><path d="M601.9 16c-18.8-18.8-49.2-18.7-67.9 0L494.4 55.7l89.3 89.3 39.8-38.9c19.1-18.7 19.2-49.4 .4-68.2L601.9 16zM328.5 221.8c-7 7-12.3 15.6-15.4 25l-23.8 71.3c-2.9 8.6-.6 18.1 5.8 24.6s15.9 8.7 24.6 5.8l71.5-23.9c9.2-3.1 17.6-8.2 24.5-15L560.8 167.5 471.7 78.4 328.5 221.8zM80 128c-44.2 0-80 35.8-80 80V432c0 44.2 35.8 80 80 80H496c44.2 0 80-35.8 80-80V304c0-17.7-14.3-32-32-32s-32 14.3-32 32V432c0 8.8-7.2 16-16 16H80c-8.8 0-16-7.2-16-16V208c0-8.8 7.2-16 16-16H272c17.7 0 32-14.3 32-32s-14.3-32-32-32H80zm80 192c0-17.7-14.3-32-32-32s-32 14.3-32 32s14.3 32 32 32s32-14.3 32-32zm64 32c17.7 0 32-14.3 32-32s-14.3-32-32-32s-32 14.3-32 32s14.3 32 32 32z"/></svg>';
        container.appendChild(codeBtnElem);
        container.appendChild(divider);
        container.appendChild(formBtnElem);
        return container;
    },
    showCodeBtn(className, onClick) {
        const btnElem = document.createElement('a');
        btnElem.classList.add(className);
        btnElem.innerHTML = _locale__WEBPACK_IMPORTED_MODULE_1__.localeText.getText(_constants__WEBPACK_IMPORTED_MODULE_3__.LocaleTextName.SHOW_CODE_BTN_TEXT);
        btnElem.addEventListener('click', onClick);
        return btnElem;
    }
};
// handle markdown separately because we need to support multiple lines parsing
let markdownRaw = '';
const markdownBuilder = {
    add(content) {
        if (markdownRaw) {
            markdownRaw += '\n' + content;
        }
        else {
            markdownRaw = content;
        }
    },
    clear() {
        markdownRaw = '';
    },
    get() {
        return markdownRaw;
    },
    build() {
        const markdownElem = document.createElement('div');
        markdownElem.classList.add(_constants__WEBPACK_IMPORTED_MODULE_3__.MARKDOWN_CLASS_NAME, _constants__WEBPACK_IMPORTED_MODULE_3__.JUPYTER_LAB_MARKDOWN_CLASS_NAME);
        markdownElem.innerHTML = marked__WEBPACK_IMPORTED_MODULE_0__.marked.parse(markdownRaw);
        return markdownElem;
    }
};


/***/ }),

/***/ "./lib/colabCommand/matcher.js":
/*!*************************************!*\
  !*** ./lib/colabCommand/matcher.js ***!
  \*************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "colabCommandMatcher": () => (/* binding */ colabCommandMatcher)
/* harmony export */ });
/* harmony import */ var _constants__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../constants */ "./lib/constants.js");

const colabCommandMatcher = (type, line) => {
    if (type === _constants__WEBPACK_IMPORTED_MODULE_0__.CommandType.Title) {
        return /#\s*@title/.exec(line);
    }
    else if (type === _constants__WEBPACK_IMPORTED_MODULE_0__.CommandType.Param) {
        return /#\s*@param/.exec(line);
    }
    else if (type === _constants__WEBPACK_IMPORTED_MODULE_0__.CommandType.Markdown) {
        return /#\s*@markdown/.exec(line);
    }
};


/***/ }),

/***/ "./lib/colabCommand/trimmer.js":
/*!*************************************!*\
  !*** ./lib/colabCommand/trimmer.js ***!
  \*************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "colabCommandTrimmer": () => (/* binding */ colabCommandTrimmer)
/* harmony export */ });
/* harmony import */ var _utils_utils__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../utils/utils */ "./lib/utils/utils.js");
/* harmony import */ var _constants__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../constants */ "./lib/constants.js");


const colabCommandTrimmer = {
    [_constants__WEBPACK_IMPORTED_MODULE_0__.CommandType.Title]: (line) => {
        return {
            value: [
                ...line.replace(/#\s*@title/, '#@title').matchAll(/#@title(.*)/g)
            ][0][1].trim()
        };
    },
    [_constants__WEBPACK_IMPORTED_MODULE_0__.CommandType.Param]: (line) => {
        let [code, colabCommand] = line
            .replace(/#\s*@param/, '#@param')
            .split('#@param');
        code = code.trim();
        colabCommand = colabCommand.trim();
        // extract the config
        const configStr = [...colabCommand.matchAll(/{.*?}/g)][0]?.pop();
        // eslint-disable-next-line @typescript-eslint/no-unsafe-assignment
        const config = configStr &&
            JSON.parse((0,_utils_utils__WEBPACK_IMPORTED_MODULE_1__.strToJSON)(configStr.replace('allow-input', 'allowInput')));
        // extract the dropdown list
        const valueListStr = [...colabCommand.matchAll(/\[.*\]/g)][0]?.pop();
        let valueList;
        // eslint-disable-next-line @typescript-eslint/no-unsafe-member-access
        if (config?.type === 'raw') {
            valueList =
                valueListStr &&
                    valueListStr
                        .slice(1, valueListStr.length - 1)
                        .split(',')
                        .map(value => value.trim());
        }
        else {
            // eslint-disable-next-line @typescript-eslint/no-unsafe-assignment
            valueList = valueListStr && JSON.parse((0,_utils_utils__WEBPACK_IMPORTED_MODULE_1__.strToJSON)(valueListStr));
        }
        // extract the variable name
        let name, value, rawValue;
        // eslint-disable-next-line prefer-const
        [, name, rawValue] = [...code.matchAll(/\s*(.*?)\s*=\s*(.*)\s*/g)][0] || [];
        if ([...code.matchAll(/\s*(.*?)\s*=\s*["'](.*)["']\s*/g)][0]) {
            [, , value] = [...code.matchAll(/\s*(.*?)\s*=\s*["'](.*)["']\s*/g)][0];
        }
        else {
            [, , value] = [...code.matchAll(/\s*(.*?)\s*=\s*(.*)\s*/g)][0] || [];
        }
        let quoteType;
        if (/'.*'/.exec(rawValue ?? '')) {
            quoteType = _constants__WEBPACK_IMPORTED_MODULE_0__.QuoteType.Single;
        }
        else if (/".*"/.exec(rawValue ?? '')) {
            quoteType = _constants__WEBPACK_IMPORTED_MODULE_0__.QuoteType.Double;
        }
        if (!(/'.*'/.exec(rawValue ?? '') || /".*"/.exec(rawValue ?? ''))) {
            value = rawValue;
        }
        // eslint-disable-next-line @typescript-eslint/no-unsafe-assignment
        return { name, value, rawValue, config, valueList, quoteType };
    },
    [_constants__WEBPACK_IMPORTED_MODULE_0__.CommandType.Markdown]: (line) => {
        return [
            ...line.replace(/#\s*@markdown/, '#@markdown').matchAll(/#@markdown(.*)/g)
        ][0][1].trim();
    }
};


/***/ }),

/***/ "./lib/colabCommand/updater.js":
/*!*************************************!*\
  !*** ./lib/colabCommand/updater.js ***!
  \*************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "colabCommandUpdater": () => (/* binding */ colabCommandUpdater)
/* harmony export */ });
/* harmony import */ var _constants__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../constants */ "./lib/constants.js");

const getQuote = (type) => {
    if (type === _constants__WEBPACK_IMPORTED_MODULE_0__.QuoteType.Single) {
        return "'";
    }
    else {
        return '"';
    }
};
const escapeString = (str, type) => {
    if (type === _constants__WEBPACK_IMPORTED_MODULE_0__.QuoteType.Single) {
        str = str.replaceAll("'", "\\'");
    }
    else {
        str = str.replaceAll('"', '\\"');
    }
    return str;
};
const colabCommandUpdater = {
    [_constants__WEBPACK_IMPORTED_MODULE_0__.CommandType.Param]: (line, replaceStr, withStr, quoteType, needQuotation) => {
        if (replaceStr) {
            return line.replace(
            // handle the normal situation like `aa = 123` or `aa = '123`
            RegExp(String.raw `=(.*)${replaceStr}(.*)#(\s*)@param`, 'g'), `=$1${withStr}$2#$3@param`);
        }
        else {
            // handle the situation like `aa = ` or `aa = ''`
            return line.replace(RegExp(String.raw `=.*#(\s*)@param`, 'g'), `= ${needQuotation
                ? getQuote(quoteType) +
                    escapeString(withStr, quoteType) +
                    getQuote(quoteType)
                : withStr} #$1@param`);
        }
    }
};


/***/ }),

/***/ "./lib/constants.js":
/*!**************************!*\
  !*** ./lib/constants.js ***!
  \**************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "BREAK_LINE_ELEMENT": () => (/* binding */ BREAK_LINE_ELEMENT),
/* harmony export */   "BuildTargetType": () => (/* binding */ BuildTargetType),
/* harmony export */   "CELL_CLASS_NAME": () => (/* binding */ CELL_CLASS_NAME),
/* harmony export */   "CELL_SHOW_CODE_CLASS_NAME": () => (/* binding */ CELL_SHOW_CODE_CLASS_NAME),
/* harmony export */   "COLAB_CLASS_NAME": () => (/* binding */ COLAB_CLASS_NAME),
/* harmony export */   "CommandType": () => (/* binding */ CommandType),
/* harmony export */   "DISPLAY_MODE_BOTH": () => (/* binding */ DISPLAY_MODE_BOTH),
/* harmony export */   "DISPLAY_MODE_CODE": () => (/* binding */ DISPLAY_MODE_CODE),
/* harmony export */   "DISPLAY_MODE_FORM": () => (/* binding */ DISPLAY_MODE_FORM),
/* harmony export */   "DISPLAY_MODE_PREFIX": () => (/* binding */ DISPLAY_MODE_PREFIX),
/* harmony export */   "DisplayMode": () => (/* binding */ DisplayMode),
/* harmony export */   "ERROR_CLASS_NAME": () => (/* binding */ ERROR_CLASS_NAME),
/* harmony export */   "ERROR_MESSAGE_CLASS_NAME": () => (/* binding */ ERROR_MESSAGE_CLASS_NAME),
/* harmony export */   "JUPYTER_LAB_MARKDOWN_CLASS_NAME": () => (/* binding */ JUPYTER_LAB_MARKDOWN_CLASS_NAME),
/* harmony export */   "LocaleTextName": () => (/* binding */ LocaleTextName),
/* harmony export */   "MARKDOWN_CLASS_NAME": () => (/* binding */ MARKDOWN_CLASS_NAME),
/* harmony export */   "PARAM_ALLOW_INPUT_INPUT": () => (/* binding */ PARAM_ALLOW_INPUT_INPUT),
/* harmony export */   "PARAM_CLASS_NAME": () => (/* binding */ PARAM_CLASS_NAME),
/* harmony export */   "PARAM_EXTEND_ELEMENT_CLASS_NAME": () => (/* binding */ PARAM_EXTEND_ELEMENT_CLASS_NAME),
/* harmony export */   "PARAM_NAME_CLASS_NAME": () => (/* binding */ PARAM_NAME_CLASS_NAME),
/* harmony export */   "PARAM_QUOTATION_CLASS_NAME": () => (/* binding */ PARAM_QUOTATION_CLASS_NAME),
/* harmony export */   "ParamType": () => (/* binding */ ParamType),
/* harmony export */   "QuoteType": () => (/* binding */ QuoteType),
/* harmony export */   "SELECT_WRAPPER_CLASS_NAME": () => (/* binding */ SELECT_WRAPPER_CLASS_NAME),
/* harmony export */   "SLIDER_VALUE_CLASS_NAME": () => (/* binding */ SLIDER_VALUE_CLASS_NAME),
/* harmony export */   "TITLE_CLASS_NAME": () => (/* binding */ TITLE_CLASS_NAME),
/* harmony export */   "TOOLBAR_BUTTON_CONTAINER_CLASS_NAME": () => (/* binding */ TOOLBAR_BUTTON_CONTAINER_CLASS_NAME),
/* harmony export */   "TOOLBAR_CODE_CLASS_NAME": () => (/* binding */ TOOLBAR_CODE_CLASS_NAME),
/* harmony export */   "TOOLBAR_FORM_CLASS_NAME": () => (/* binding */ TOOLBAR_FORM_CLASS_NAME),
/* harmony export */   "TOOLBAR_INJECTION_SELECTOR": () => (/* binding */ TOOLBAR_INJECTION_SELECTOR)
/* harmony export */ });
const ERROR_MESSAGE_CLASS_NAME = 'colab-cell__param-error-message';
const SLIDER_VALUE_CLASS_NAME = 'colab-cell__param-slider-value';
const SELECT_WRAPPER_CLASS_NAME = 'colab-cell__param-select-wrapper';
const PARAM_QUOTATION_CLASS_NAME = 'colab-cell__param-quotation';
const PARAM_CLASS_NAME = 'colab-cell__param';
const PARAM_NAME_CLASS_NAME = 'colab-cell__param-name';
const PARAM_EXTEND_ELEMENT_CLASS_NAME = 'colab-cell__param-extend';
const PARAM_ALLOW_INPUT_INPUT = 'colab-cell__param-allow-input-input';
const TITLE_CLASS_NAME = 'colab-cell__title';
const MARKDOWN_CLASS_NAME = 'colab-cell__markdown';
const JUPYTER_LAB_MARKDOWN_CLASS_NAME = 'jp-RenderedHTMLCommon';
const COLAB_CLASS_NAME = 'colab-container';
const TOOLBAR_BUTTON_CONTAINER_CLASS_NAME = 'colab-cell__toolbar-button-container';
const TOOLBAR_CODE_CLASS_NAME = 'colab-cell__toolbar-code-btn';
const TOOLBAR_FORM_CLASS_NAME = 'colab-cell__toolbar-form-btn';
const CELL_SHOW_CODE_CLASS_NAME = 'colab-cell__show-code-btn';
const DISPLAY_MODE_CODE = 'colab-display-mode-code';
const DISPLAY_MODE_FORM = 'colab-display-mode-form';
const DISPLAY_MODE_BOTH = 'colab-display-mode-both';
const DISPLAY_MODE_PREFIX = 'colab-display-mode-';
const CELL_CLASS_NAME = 'colab-cell';
const BREAK_LINE_ELEMENT = 'colab-cell__break-line';
const ERROR_CLASS_NAME = 'error';
const TOOLBAR_INJECTION_SELECTOR = '.jp-cell-menu.jp-cell-toolbar';
var CommandType;
(function (CommandType) {
    CommandType["Title"] = "title";
    CommandType["Param"] = "param";
    CommandType["Markdown"] = "markdown";
})(CommandType || (CommandType = {}));
var ParamType;
(function (ParamType) {
    ParamType["String"] = "string";
    ParamType["Raw"] = "raw";
    ParamType["Number"] = "number";
    ParamType["Integer"] = "integer";
    ParamType["Date"] = "date";
    ParamType["Boolean"] = "boolean";
    ParamType["Slider"] = "slider";
})(ParamType || (ParamType = {}));
var DisplayMode;
(function (DisplayMode) {
    DisplayMode["Code"] = "code";
    DisplayMode["Form"] = "form";
    DisplayMode["Both"] = "both";
})(DisplayMode || (DisplayMode = {}));
var LocaleTextName;
(function (LocaleTextName) {
    LocaleTextName[LocaleTextName["NUMBER_ERROR_MESSAGE"] = 0] = "NUMBER_ERROR_MESSAGE";
    LocaleTextName[LocaleTextName["SLIDER_ERROR_MESSAGE"] = 1] = "SLIDER_ERROR_MESSAGE";
    LocaleTextName[LocaleTextName["INTEGER_ERROR_MESSAGE"] = 2] = "INTEGER_ERROR_MESSAGE";
    LocaleTextName[LocaleTextName["SHOW_CODE_BTN_TEXT"] = 3] = "SHOW_CODE_BTN_TEXT";
    LocaleTextName[LocaleTextName["ASSERT_ERROR_MESSAGE_FN"] = 4] = "ASSERT_ERROR_MESSAGE_FN";
    LocaleTextName[LocaleTextName["CELL_BUILD_ERROR_MESSAGE_FN"] = 5] = "CELL_BUILD_ERROR_MESSAGE_FN";
})(LocaleTextName || (LocaleTextName = {}));
var BuildTargetType;
(function (BuildTargetType) {
    BuildTargetType["ValueList"] = "value-list";
    BuildTargetType["InputStringOrRaw"] = "input-string-raw";
    BuildTargetType["InputNumberOrIntegerOrDate"] = "input-number-integer-date";
    BuildTargetType["Checkbox"] = "checkbox";
    BuildTargetType["Slider"] = "slider";
})(BuildTargetType || (BuildTargetType = {}));
var QuoteType;
(function (QuoteType) {
    QuoteType["Single"] = "single";
    QuoteType["Double"] = "double";
})(QuoteType || (QuoteType = {}));


/***/ }),

/***/ "./lib/index.js":
/*!**********************!*\
  !*** ./lib/index.js ***!
  \**********************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @jupyterlab/notebook */ "webpack/sharing/consume/default/@jupyterlab/notebook");
/* harmony import */ var _jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _jupyterlab_codeeditor__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @jupyterlab/codeeditor */ "webpack/sharing/consume/default/@jupyterlab/codeeditor");
/* harmony import */ var _jupyterlab_codeeditor__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_codeeditor__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _colabCell__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./colabCell */ "./lib/colabCell.js");



class ColabCodeContentFactory extends _jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_0__.NotebookPanel.ContentFactory {
    /**
     * Create a new markdown cell widget.
     *
     * #### Notes
     * If no cell content factory is passed in with the options, the one on the
     * notebook content factory is used.
     */
    createCodeCell(options, parent) {
        if (!options.contentFactory) {
            options.contentFactory = this;
        }
        return new _colabCell__WEBPACK_IMPORTED_MODULE_2__.ColabCodeCell(options).initializeState();
    }
}
/**
 * The notebook cell factory provider.
 */
const codeFactory = {
    id: '@signcl/jupyterlab-colab-bridge:factory',
    provides: _jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_0__.NotebookPanel.IContentFactory,
    requires: [_jupyterlab_codeeditor__WEBPACK_IMPORTED_MODULE_1__.IEditorServices],
    autoStart: true,
    activate: (app, editorServices) => {
        console.log('Using jupyterlab-colab-bridge:factory');
        // eslint-disable-next-line @typescript-eslint/unbound-method
        const editorFactory = editorServices.factoryService.newInlineEditor;
        return new ColabCodeContentFactory({ editorFactory });
    }
};
/**
 * The notebook cell executor.
 */
const executor = {
    id: '@signcl/jupyterlab-colab-bridge:executor',
    requires: [_jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_0__.INotebookTracker],
    autoStart: true,
    activate: (app, tracker) => {
        console.log('Using jupyterlab-colab-bridge:executor');
        tracker.activeCellChanged.connect(event => {
            const cell = event.activeCell;
            if (cell &&
                cell.model.type === 'code' &&
                /#\s*@(title|param|markdown)/.exec(cell.model.value.text)) {
                setTimeout(() => cell.injectToolbarBtns(), 0);
            }
        });
        return;
    }
};
/**
 * Export the plugins as default.
 */
const plugins = [codeFactory, executor];
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (plugins);


/***/ }),

/***/ "./lib/locale/en.js":
/*!**************************!*\
  !*** ./lib/locale/en.js ***!
  \**************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "localeText": () => (/* binding */ localeText)
/* harmony export */ });
/* harmony import */ var _constants__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../constants */ "./lib/constants.js");

const fieldNameMap = {
    name: 'variable name'
};
const localeText = {
    text: {
        [_constants__WEBPACK_IMPORTED_MODULE_0__.LocaleTextName.NUMBER_ERROR_MESSAGE]: 'illegal number format',
        [_constants__WEBPACK_IMPORTED_MODULE_0__.LocaleTextName.SLIDER_ERROR_MESSAGE]: 'value must be a number and with in the [min, max] range',
        [_constants__WEBPACK_IMPORTED_MODULE_0__.LocaleTextName.INTEGER_ERROR_MESSAGE]: 'illegal integer',
        [_constants__WEBPACK_IMPORTED_MODULE_0__.LocaleTextName.SHOW_CODE_BTN_TEXT]: 'Show code'
    },
    fn: {
        [_constants__WEBPACK_IMPORTED_MODULE_0__.LocaleTextName.ASSERT_ERROR_MESSAGE_FN]: (field) => `could not find[${fieldNameMap[field] || field}], please check the code`,
        [_constants__WEBPACK_IMPORTED_MODULE_0__.LocaleTextName.CELL_BUILD_ERROR_MESSAGE_FN]: (line) => 'parse error,' + line + ' is not the correct command format'
    }
};


/***/ }),

/***/ "./lib/locale/index.js":
/*!*****************************!*\
  !*** ./lib/locale/index.js ***!
  \*****************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "localeText": () => (/* binding */ localeText)
/* harmony export */ });
/* harmony import */ var _zh_CN__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./zh_CN */ "./lib/locale/zh_CN.js");
/* harmony import */ var _en__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./en */ "./lib/locale/en.js");


let lang = 'zh_CN';
const localeTextMap = {
    zh_CN: _zh_CN__WEBPACK_IMPORTED_MODULE_0__.localeText.text,
    en: _en__WEBPACK_IMPORTED_MODULE_1__.localeText.text
};
const localeTextFnMap = {
    zh_CN: _zh_CN__WEBPACK_IMPORTED_MODULE_0__.localeText.fn,
    en: _en__WEBPACK_IMPORTED_MODULE_1__.localeText.fn
};
const localeText = {
    setLang: (val) => {
        if (val in localeTextMap) {
            lang = val;
        }
    },
    getLang: () => lang,
    getText: (name) => localeTextMap[lang][name],
    getTextFn: (name) => localeTextFnMap[lang][name]
};


/***/ }),

/***/ "./lib/locale/zh_CN.js":
/*!*****************************!*\
  !*** ./lib/locale/zh_CN.js ***!
  \*****************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "localeText": () => (/* binding */ localeText)
/* harmony export */ });
/* harmony import */ var _constants__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../constants */ "./lib/constants.js");

const fieldNameMap = {
    name: '变量名'
};
const localeText = {
    text: {
        [_constants__WEBPACK_IMPORTED_MODULE_0__.LocaleTextName.NUMBER_ERROR_MESSAGE]: '不是合法的数字格式',
        [_constants__WEBPACK_IMPORTED_MODULE_0__.LocaleTextName.SLIDER_ERROR_MESSAGE]: '值必须是数字，并且在[min, max]范围内',
        [_constants__WEBPACK_IMPORTED_MODULE_0__.LocaleTextName.INTEGER_ERROR_MESSAGE]: '不是合法的整数',
        [_constants__WEBPACK_IMPORTED_MODULE_0__.LocaleTextName.SHOW_CODE_BTN_TEXT]: '显示代码'
    },
    fn: {
        [_constants__WEBPACK_IMPORTED_MODULE_0__.LocaleTextName.ASSERT_ERROR_MESSAGE_FN]: (field) => `无法找到[${fieldNameMap[field] || field}]，请检查代码格式`,
        [_constants__WEBPACK_IMPORTED_MODULE_0__.LocaleTextName.CELL_BUILD_ERROR_MESSAGE_FN]: (line) => '解析出错，' + line + ' 不是正确的命令格式'
    }
};


/***/ }),

/***/ "./lib/utils/cache.js":
/*!****************************!*\
  !*** ./lib/utils/cache.js ***!
  \****************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "LRUCache": () => (/* binding */ LRUCache)
/* harmony export */ });
/* eslint-disable @typescript-eslint/no-unsafe-assignment */
// a simple LRU cache implementation
class LRUCache {
    constructor(maxSize = 100) {
        this.maxSize = maxSize;
        this.storage = {};
        this.hitCount = {};
    }
    set(key, value) {
        if (Object.keys(this.storage).length >= this.maxSize) {
            const keys = Object.keys(this.hitCount);
            keys.sort((a, b) => this.hitCount[a] - this.hitCount[b]);
            delete this.storage[keys[0]];
            delete this.hitCount[keys[0]];
        }
        this.storage[key] = value;
        this.hitCount[key] = 0;
    }
    get(key) {
        if (this.storage[key]) {
            this.hitCount[key]++;
            return this.storage[key];
        }
    }
    remove(key) {
        if (this.storage[key]) {
            delete this.storage[key];
            delete this.hitCount[key];
        }
    }
    clear() {
        this.storage = {};
        this.hitCount = {};
    }
}


/***/ }),

/***/ "./lib/utils/pubsub.js":
/*!*****************************!*\
  !*** ./lib/utils/pubsub.js ***!
  \*****************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* eslint-disable @typescript-eslint/no-unsafe-return */
/* eslint-disable @typescript-eslint/ban-types */
/* eslint-disable @typescript-eslint/naming-convention */
class PubSub {
    constructor() {
        this.subIds = 0;
        this.subscriptions = {};
    }
    subscribe(topic, fn) {
        if (!this.subscriptions[topic]) {
            this.subscriptions[topic] = {};
        }
        const token = ++this.subIds;
        // Validate topic name and function constructor
        this.subscriptions[topic][token] = fn;
        return () => this.unsubscribe(topic, token);
    }
    publish(topic, ...args) {
        const subs = this.subscriptions[topic];
        if (!subs) {
            return false;
        }
        // eslint-disable-next-line @typescript-eslint/no-unsafe-call
        Object.values(subs).forEach(sub => sub(...args));
    }
    unsubscribe(topic, token) {
        if (!token) {
            delete this.subscriptions[topic]; // Delete all subscriptions for the topic
        }
        else {
            this.subscriptions[topic] && delete this.subscriptions[topic][token]; // Delete specific subscription
        }
    }
}
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (new PubSub());


/***/ }),

/***/ "./lib/utils/utils.js":
/*!****************************!*\
  !*** ./lib/utils/utils.js ***!
  \****************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "strToJSON": () => (/* binding */ strToJSON)
/* harmony export */ });
// colab is not using the real JSON string format
// for example, the property names are not wrapped in double quotations
// so we have to convert it first before parsing
const strToJSON = (str) => str.replace(/(\w+:)|(\w+ :)/g, s => {
    return '"' + s.substring(0, s.length - 1) + '":';
});


/***/ })

}]);
//# sourceMappingURL=lib_index_js.5b547773d4bd652f2fcf.js.map