import { colabCommandMatcher } from './matcher';
import { CommandType } from '../constants';

describe('test matcher', () => {
  test('should match the title', () => {
    expect(colabCommandMatcher(CommandType.Title, '#@title123')).toBeTruthy();
    expect(colabCommandMatcher(CommandType.Title, '#@title 123')).toBeTruthy();
    expect(colabCommandMatcher(CommandType.Title, ' #@title123')).toBeTruthy();
    expect(colabCommandMatcher(CommandType.Title, ' #@title 123')).toBeTruthy();
    expect(
      colabCommandMatcher(CommandType.Title, 'a = 123 #@title123')
    ).toBeTruthy();
    expect(
      colabCommandMatcher(CommandType.Title, 'a = 123 #@title 123')
    ).toBeTruthy();
    expect(colabCommandMatcher(CommandType.Title, '# @title 123')).toBeTruthy();
  });

  test('should not match the title', () => {
    expect(colabCommandMatcher(CommandType.Title, '#@Title')).toBeFalsy();
    expect(colabCommandMatcher(CommandType.Title, '#@ title 123')).toBeFalsy();
  });

  test('should match the markdown', () => {
    expect(
      colabCommandMatcher(CommandType.Markdown, '#@markdown123')
    ).toBeTruthy();
    expect(
      colabCommandMatcher(CommandType.Markdown, '#@markdown 123')
    ).toBeTruthy();
    expect(
      colabCommandMatcher(CommandType.Markdown, ' #@markdown123')
    ).toBeTruthy();
    expect(
      colabCommandMatcher(CommandType.Markdown, ' #@markdown 123')
    ).toBeTruthy();
    expect(
      colabCommandMatcher(CommandType.Markdown, 'a = 123 #@markdown123')
    ).toBeTruthy();
    expect(
      colabCommandMatcher(CommandType.Markdown, 'a = 123 #@markdown 123')
    ).toBeTruthy();
    expect(
      colabCommandMatcher(CommandType.Markdown, '# @markdown 123')
    ).toBeTruthy();
  });

  test('should not match the markdown', () => {
    expect(colabCommandMatcher(CommandType.Markdown, '#@Markdown')).toBeFalsy();
    expect(
      colabCommandMatcher(CommandType.Markdown, '#@ markdown 123')
    ).toBeFalsy();
  });
});
