import { colabCommandUpdater } from './updater';
import { CommandType, QuoteType } from '../constants';

describe('test param updater', () => {
  test('should update the code', () => {
    expect(
      colabCommandUpdater[CommandType.Param](
        'aa = 123#@param',
        '123',
        '234',
        undefined
      )
    ).toEqual('aa = 234#@param');

    expect(
      colabCommandUpdater[CommandType.Param](
        'aa = 123#@param',
        '123',
        '234',
        undefined,
        true
      )
    ).toEqual('aa = 234#@param');

    expect(
      colabCommandUpdater[CommandType.Param](
        'aa =#@param',
        undefined,
        '234',
        undefined
      )
    ).toEqual('aa = 234 #@param');

    expect(
      colabCommandUpdater[CommandType.Param](
        'aa =#@param',
        undefined,
        '234',
        undefined,
        true
      )
    ).toEqual('aa = "234" #@param');

    expect(
      colabCommandUpdater[CommandType.Param](
        "aa =''#@param",
        undefined,
        '234',
        QuoteType.Single,
        true
      )
    ).toEqual("aa = '234' #@param");

    expect(
      colabCommandUpdater[CommandType.Param](
        'aa =""#@param',
        undefined,
        '234',
        QuoteType.Double,
        true
      )
    ).toEqual('aa = "234" #@param');

    expect(
      colabCommandUpdater[CommandType.Param](
        'aa =123#@param',
        undefined,
        '234',
        QuoteType.Double,
        true
      )
    ).toEqual('aa = "234" #@param');
  });
});
