export const ERROR_MESSAGE_CLASS_NAME = 'colab-cell__param-error-message';
export const SLIDER_VALUE_CLASS_NAME = 'colab-cell__param-slider-value';
export const SELECT_WRAPPER_CLASS_NAME = 'colab-cell__param-select-wrapper';
export const PARAM_QUOTATION_CLASS_NAME = 'colab-cell__param-quotation';
export const PARAM_CLASS_NAME = 'colab-cell__param';
export const PARAM_NAME_CLASS_NAME = 'colab-cell__param-name';
export const PARAM_EXTEND_ELEMENT_CLASS_NAME = 'colab-cell__param-extend';
export const PARAM_ALLOW_INPUT_INPUT = 'colab-cell__param-allow-input-input';
export const TITLE_CLASS_NAME = 'colab-cell__title';
export const MARKDOWN_CLASS_NAME = 'colab-cell__markdown';
export const JUPYTER_LAB_MARKDOWN_CLASS_NAME = 'jp-RenderedHTMLCommon';
export const COLAB_CLASS_NAME = 'colab-container';
export const TOOLBAR_BUTTON_CONTAINER_CLASS_NAME =
  'colab-cell__toolbar-button-container';
export const TOOLBAR_CODE_CLASS_NAME = 'colab-cell__toolbar-code-btn';
export const TOOLBAR_FORM_CLASS_NAME = 'colab-cell__toolbar-form-btn';
export const CELL_SHOW_CODE_CLASS_NAME = 'colab-cell__show-code-btn';
export const DISPLAY_MODE_CODE = 'colab-display-mode-code';
export const DISPLAY_MODE_FORM = 'colab-display-mode-form';
export const DISPLAY_MODE_BOTH = 'colab-display-mode-both';
export const DISPLAY_MODE_PREFIX = 'colab-display-mode-';
export const CELL_CLASS_NAME = 'colab-cell';
export const BREAK_LINE_ELEMENT = 'colab-cell__break-line';
export const ERROR_CLASS_NAME = 'error';
export const TOOLBAR_INJECTION_SELECTOR = '.jp-cell-menu.jp-cell-toolbar';
export enum CommandType {
  Title = 'title',
  Param = 'param',
  Markdown = 'markdown'
}
export enum ParamType {
  String = 'string',
  Raw = 'raw',
  Number = 'number',
  Integer = 'integer',
  Date = 'date',
  Boolean = 'boolean',
  Slider = 'slider'
}
export enum DisplayMode {
  Code = 'code',
  Form = 'form',
  Both = 'both'
}

export enum LocaleTextName {
  NUMBER_ERROR_MESSAGE,
  SLIDER_ERROR_MESSAGE,
  INTEGER_ERROR_MESSAGE,
  SHOW_CODE_BTN_TEXT,
  ASSERT_ERROR_MESSAGE_FN,
  CELL_BUILD_ERROR_MESSAGE_FN
}

export type ParamObj = {
  name: string;
  value?: string;
  rawValue?: string;
  config: {
    type: ParamType;
    allowInput?: boolean;
    min?: number;
    max?: number;
    step?: number;
  };
  valueList?: any[];
  quoteType?: QuoteType;
};

export enum BuildTargetType {
  ValueList = 'value-list',
  InputStringOrRaw = 'input-string-raw',
  InputNumberOrIntegerOrDate = 'input-number-integer-date',
  Checkbox = 'checkbox',
  Slider = 'slider'
}

export enum QuoteType {
  Single = 'single',
  Double = 'double'
}
