import { localeText as zh_CN } from './zh_CN';
import { localeText as en } from './en';
import { LocaleTextName } from '../constants';

let lang = 'zh_CN';

const localeTextMap: Record<string, Record<number, string>> = {
  zh_CN: zh_CN.text,
  en: en.text
};

const localeTextFnMap: Record<
  string,
  Record<string, (arg0: string) => string>
> = {
  zh_CN: zh_CN.fn,
  en: en.fn
};

export const localeText = {
  setLang: (val: string): void => {
    if (val in localeTextMap) {
      lang = val;
    }
  },
  getLang: (): string => lang,
  getText: (name: LocaleTextName): string => localeTextMap[lang][name],
  getTextFn: (name: LocaleTextName): ((arg0: string) => string) =>
    localeTextFnMap[lang][name]
};
