import pubsub from './pubsub';

const MOCK_EVENT_NAME = 'event';

let callbackFn = jest.fn();

describe('test pubsub', () => {
  beforeEach(() => {
    callbackFn = jest.fn();
  });

  afterEach(() => {
    pubsub.unsubscribe(MOCK_EVENT_NAME);
  });

  test('should trigger the callback function', () => {
    pubsub.subscribe(MOCK_EVENT_NAME, callbackFn);
    pubsub.publish(MOCK_EVENT_NAME);
    expect(callbackFn).toBeCalledTimes(1);
  });

  test('should not trigger the callback function when unsubsribed', () => {
    const unsubscribe = pubsub.subscribe(MOCK_EVENT_NAME, callbackFn);
    unsubscribe();
    pubsub.publish(MOCK_EVENT_NAME);
    expect(callbackFn).not.toBeCalled();
  });
});
